////////////////////////////////////////////////////////////////////////
//
//      Fichier: Canal_impl.hpp
//       Auteur: Stephane Drouin
//     Creation: 07/02/01 15:10:26
// Modification: 28/03/01
//				 Implantation d'un canal caloporteur distribue
// Modification: 04/04/01
//               Ajout de la methode Detruire()
//  Description: Canal caloporteur.
//
////////////////////////////////////////////////////////////////////////

#ifndef __BARRE_IMPL_H__
#define __BARRE_IMPL_H__

#include <Reacteur_skel.h>

class Canal_impl : public POA_Canal, public PortableServer::RefCountServantBase {

public:
	~Canal_impl();

	// Initialisation de la simulation et verification des parametres
	virtual void Initialisation(const ParametresSimulation& par)
		throw(MauvaisParametres, CORBA::SystemException);

	// Le client doit detruire le servant apres utilisation
	virtual void Detruire() throw(CORBA::SystemException);

	// Obtenir la temperature moyenne du canal
	virtual TempType temp_moy() throw(CORBA::SystemException);

	// Calcul d'une iteration de 'pas' secondes, avec gradients voisins 1 et 2
	virtual void Iteration(TimeType pas, TempType grad_1, TempType grad_2)
		throw(ErreurCalcul,CORBA::SystemException);;

private:
  ParametresSimulation p;		// Tous les parametres de simulation
  TempType tc;					// Temperature moyenne courante du canal
};

#endif